
// ModelViewerView.cpp : CModelViewerView NX̎
//

#include "stdafx.h"
// SHARED_HANDLERS ́Avr[AkŁAьtB^[ nh[Ă ATL vWFNgŒ`łA
// ̃vWFNgƂ̃hLg R[h̋L\ɂ܂B
#ifndef SHARED_HANDLERS
#include "ModelViewer.h"
#endif

#include "ModelViewerDoc.h"
#include "ModelViewerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CModelViewerView

IMPLEMENT_DYNCREATE(CModelViewerView, COpenGLPickView)

BEGIN_MESSAGE_MAP(CModelViewerView, COpenGLPickView)
	ON_COMMAND( ID_VIEW_ROTATION, &CModelViewerView::OnViewRotation )
	ON_COMMAND( ID_VIEW_PAN, &CModelViewerView::OnViewPan )
	ON_COMMAND( ID_VIEW_ZOOM, &CModelViewerView::OnViewZoom )
	ON_UPDATE_COMMAND_UI( ID_VIEW_ROTATION, &CModelViewerView::OnUpdateViewRotation )
	ON_UPDATE_COMMAND_UI( ID_VIEW_PAN, &CModelViewerView::OnUpdateViewPan )
	ON_UPDATE_COMMAND_UI( ID_VIEW_ZOOM, &CModelViewerView::OnUpdateViewZoom )
	ON_COMMAND( ID_VIEW_RENDERPOINT, &CModelViewerView::OnViewRenderpoint )
	ON_COMMAND( ID_VIEW_RENDERLINE, &CModelViewerView::OnViewRenderline )
	ON_COMMAND( ID_VIEW_RENDERFACE, &CModelViewerView::OnViewRenderface )
	ON_UPDATE_COMMAND_UI( ID_VIEW_RENDERPOINT, &CModelViewerView::OnUpdateViewRenderpoint )
	ON_UPDATE_COMMAND_UI( ID_VIEW_RENDERLINE, &CModelViewerView::OnUpdateViewRenderline )
	ON_UPDATE_COMMAND_UI( ID_VIEW_RENDERFACE, &CModelViewerView::OnUpdateViewRenderface )
	ON_COMMAND( ID_VIEW_PICKPOINT, &CModelViewerView::OnViewPickpoint )
	ON_COMMAND( ID_VIEW_PICKLINE, &CModelViewerView::OnViewPickline )
	ON_COMMAND( ID_VIEW_PICKFACE, &CModelViewerView::OnViewPickface )
	ON_UPDATE_COMMAND_UI( ID_VIEW_PICKPOINT, &CModelViewerView::OnUpdateViewPickpoint )
	ON_UPDATE_COMMAND_UI( ID_VIEW_PICKLINE, &CModelViewerView::OnUpdateViewPickline )
	ON_UPDATE_COMMAND_UI( ID_VIEW_PICKFACE, &CModelViewerView::OnUpdateViewPickface )
END_MESSAGE_MAP()

// CModelViewerView RXgNV/fXgNV

CModelViewerView::CModelViewerView() :
	m_bRotation( TRUE ),
	m_bPan( TRUE ),
	m_bZoom( TRUE ),
	m_bRenderPoint( TRUE ),
	m_bRenderLine( TRUE ),
	m_bRenderFace( TRUE ),
	m_bPickPoint( TRUE ),
	m_bPickLine( TRUE ),
	m_bPickFace( TRUE )
{
	// TODO: \zR[hɒǉ܂B

}

CModelViewerView::~CModelViewerView()
{
}

BOOL CModelViewerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return COpenGLPickView::PreCreateWindow(cs);
}

// CModelViewerView `

//void CModelViewerView::OnDraw(CDC* /*pDC*/)
//{
//	CModelViewerDoc* pDoc = GetDocument();
//	ASSERT_VALID(pDoc);
//	if (!pDoc)
//		return;
//
//	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
//}


// CModelViewerView ff

#ifdef _DEBUG
void CModelViewerView::AssertValid() const
{
	COpenGLPickView::AssertValid();
}

void CModelViewerView::Dump(CDumpContext& dc) const
{
	COpenGLPickView::Dump(dc);
}

CModelViewerDoc* CModelViewerView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CModelViewerDoc)));
	return (CModelViewerDoc*)m_pDocument;
}
#endif //_DEBUG

void CModelViewerView::DoTracking( CPoint point )
{
	if( ( TM_ROTATION == m_eTrackingMode && !m_bRotation )
		|| ( TM_PAN == m_eTrackingMode && !m_bPan )
		|| ( TM_ZOOM == m_eTrackingMode && !m_bZoom ) )
	{       // ȃ}EXΉ
		return;
	}

	// eNX̊֐̌Ăяo
	COpenGLPickView::DoTracking( point );
}

void CModelViewerView::RenderModel( ERENDERMODE eRenderMode )
{
	unsigned int uiCountPoint = 8;
	float points[8][3] = { -5, -5, -5,
							  5, -5, -5,
							  5,  5, -5,
							 -5,  5, -5,
							 -5, -5,  5,
							  5, -5,  5,
							  5,  5,  5,
							 -5,  5,  5 };
	unsigned int uiCountTriangle = 12;
	unsigned int triangles[12][3] = { 0, 1, 3,
							  1, 2, 3,
							  1, 5, 2,
							  5, 6, 2,
							  5, 4, 6,
							  4, 7, 6,
							  4, 0, 7,
							  0, 3, 7,
							  3, 2, 7,
							  2, 6, 7,
							  4, 5, 0,
							  5, 1, 0 };
	unsigned int uiIndexTriangle;
	unsigned int uiIndexLine;
	unsigned int uiIndexPoint;
	unsigned int ui3;

	glPushAttrib( GL_ALL_ATTRIB_BITS );	// Agr[gAł悤ɁAǉ

	// 
	if( m_bRenderFace )
	{
		if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.5f, 0.0f );
		}
		if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );
		}
		for( uiIndexTriangle = 0; uiIndexTriangle < uiCountTriangle; uiIndexTriangle++ )
		{
			if( RM_PICK_ELEMENTID == eRenderMode )
			{
				glColor3ub( GetRValue(uiIndexTriangle), GetGValue(uiIndexTriangle), GetBValue(uiIndexTriangle) );
			}
			glBegin( GL_TRIANGLES );
			glVertex3fv( points[triangles[uiIndexTriangle][0]] );
			glVertex3fv( points[triangles[uiIndexTriangle][1]] );
			glVertex3fv( points[triangles[uiIndexTriangle][2]] );
			glEnd();
		}
		// sbNʂ̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_FACE == m_auiName_picked[1] )
			{
				uiIndexTriangle = m_auiName_picked[2];
				glColor3f( 1.0f, 1.0f, 0.0f );	// sbNF
				glBegin( GL_TRIANGLES );
				glVertex3fv( points[triangles[uiIndexTriangle][0]] );
				glVertex3fv( points[triangles[uiIndexTriangle][1]] );
				glVertex3fv( points[triangles[uiIndexTriangle][2]] );
				glEnd();
			}
		}
	}
	// 
	if( m_bRenderLine )
	{
		glLineWidth( 2.0 );
		if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.0f, 0.5f, 0.5f );
		}
		if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 0.0f, 1.0f, 0.0f );
		}
		for( uiIndexTriangle = 0; uiIndexTriangle < uiCountTriangle; ++uiIndexTriangle )
		{
			for( ui3 = 0; ui3 < 3; ++ui3 )
			{
				if( RM_PICK_ELEMENTID == eRenderMode )
				{
					uiIndexLine = uiIndexTriangle * 3 + ui3;
					glColor3ub( GetRValue(uiIndexLine), GetGValue(uiIndexLine), GetBValue(uiIndexLine) );
				}
				glBegin( GL_LINES );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 0 ) % 3]] );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 1 ) % 3]] );
				glEnd();
			}
		}
		// sbN̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_LINE == m_auiName_picked[1] )
			{
				uiIndexLine = m_auiName_picked[2];
				uiIndexTriangle = uiIndexLine / 3;
				ui3 = uiIndexLine % 3;
				glLineWidth( 5.0f );
				glColor3f( 0.0f, 1.0f, 1.0f );
				glBegin( GL_LINES );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 0 ) % 3]] );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 1 ) % 3]] );
				glEnd();
			}
		}
	}
	// _
	if( m_bRenderPoint )
	{
		glPointSize( 5.0 );
		if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.0f, 0.5f );
		}
		if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 0.0f, 0.0f, 1.0f );
		}
		for( uiIndexPoint = 0; uiIndexPoint < uiCountPoint; uiIndexPoint++ )
		{
			if( RM_PICK_ELEMENTID == eRenderMode )
			{
				glColor3ub( GetRValue(uiIndexPoint), GetGValue(uiIndexPoint), GetBValue(uiIndexPoint) );
			}
			glBegin( GL_POINTS );
			glVertex3fv( points[uiIndexPoint] );
			glEnd();
		}
		// sbN_̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_POINT == m_auiName_picked[1] )
			{
				glPointSize( 10.0f );
				glColor3f( 1.0f, 0.0f, 1.0f );
				uiIndexPoint = m_auiName_picked[2];
				glBegin( GL_POINTS );
				glVertex3fv( points[uiIndexPoint] );
				glEnd();
			}
		}
	}

	glPopAttrib();	// Agr[g̕A
	return;
}

void CModelViewerView::IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int aauiNamePickRegionPixel[][NAMEARRAYSIZE] )
{
	int  iId_selected = -1;
	unsigned int  uiElementType_selected = RET_FACE + 1;
	long lSquareDist_selected = ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET ) + ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET );
	long lSquareDist_current;
	int  x;
	int  y;
	for( unsigned int ui = 0; ui < uiCountPickRegionPixel; ui++ )
	{
		if( 0 == aauiNamePickRegionPixel[ui][1] )
		{ // f̊O
			continue;
		}

		if( !m_bPickPoint && RET_POINT == aauiNamePickRegionPixel[ui][1] )
		{	// _sbNOFF̏ꍇ́A_̓sbNłȂ
			continue;
		}
		if( !m_bPickLine && RET_LINE == aauiNamePickRegionPixel[ui][1] )
		{	// sbNOFF̏ꍇ́A̓sbNłȂ
			continue;
		}
		if( !m_bPickFace && RET_FACE == aauiNamePickRegionPixel[ui][1] )
		{	// ʃsbNOFF̏ꍇ́Aʂ̓sbNłȂ
			continue;
		}

		if( uiElementType_selected < aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			continue;
		}
		if( uiElementType_selected > aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			lSquareDist_selected = x * x + y * y;
			continue;
		}
		// vf^CvIɁAD揇ʂꍇ́AsbN̈̒Sɋ߂̂DxB
		x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		lSquareDist_current = x * x + y * y;
		if( lSquareDist_selected > lSquareDist_current )
		{
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			lSquareDist_selected = lSquareDist_current;
			continue;
		}
	}

	if( -1 == iId_selected )
	{
		return;
	}

	// O񃁃o̍XV
	memcpy( m_auiName_picked, aauiNamePickRegionPixel[iId_selected], NAMEARRAYSIZE * sizeof( unsigned int) );
}

// CModelViewerView bZ[W nh[


void CModelViewerView::OnViewRotation()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bRotation = !m_bRotation;
}

void CModelViewerView::OnViewPan()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bPan = !m_bPan;
}

void CModelViewerView::OnViewZoom()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bZoom = !m_bZoom;
}

void CModelViewerView::OnUpdateViewRotation( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bRotation );
}

void CModelViewerView::OnUpdateViewPan( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bPan );
}

void CModelViewerView::OnUpdateViewZoom( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bZoom );
}

void CModelViewerView::OnViewRenderpoint()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bRenderPoint = !m_bRenderPoint;
	Invalidate( FALSE );
}

void CModelViewerView::OnViewRenderline()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bRenderLine = !m_bRenderLine;
	Invalidate( FALSE );
}

void CModelViewerView::OnViewRenderface()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bRenderFace = !m_bRenderFace;
	Invalidate( FALSE );
}

void CModelViewerView::OnUpdateViewRenderpoint( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bRenderPoint );
}

void CModelViewerView::OnUpdateViewRenderline( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bRenderLine );
}

void CModelViewerView::OnUpdateViewRenderface( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bRenderFace );
}

void CModelViewerView::OnViewPickpoint()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bPickPoint = !m_bPickPoint;
	Invalidate( FALSE );
}

void CModelViewerView::OnViewPickline()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bPickLine = !m_bPickLine;
	Invalidate( FALSE );
}

void CModelViewerView::OnViewPickface()
{
	// TODO: ɃR}h nh R[hǉ܂B
	m_bPickFace = !m_bPickFace;
	Invalidate( FALSE );
}

void CModelViewerView::OnUpdateViewPickpoint( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bPickPoint );
}

void CModelViewerView::OnUpdateViewPickline( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bPickLine );
}

void CModelViewerView::OnUpdateViewPickface( CCmdUI *pCmdUI )
{
	// TODO: ɃR}hXV UI nh R[hǉ܂B
	pCmdUI->SetCheck( m_bPickFace );
}

